classdef (SharedTestFixtures={...
    check_mds,setup_gdatpaths}) ...
    test_requestnames < matlab.unittest.TestCase
  
  properties (Abstract)
    Machine;
    Skiplist; % tests to skip
  end
  
  properties(TestParameter,Abstract)
    % parameters that will vary during tests
    shot;
    request; % placeholders
  end
  
  methods(Test)
    function test_gdat_call(testCase,shot,request)
      testCase.assertTrue(isnumeric(str2double(shot)));
      testCase.assertTrue(ischar(request));
      
      testCase.assumeFalse(ismember(testCase.Skiplist,request),...
        'Skipped request %s since it is on the skiplist for %s',request,testCase.Machine);
      
      % gdat call
      gdat_call = sprintf(['gdat_' lower(testCase.Machine) '(%s,''%s'')'],shot,request);
      
      % logging
      fprintf('Testing gdat call: %s\n',gdat_call);
      
      gdat_out = eval(gdat_call); %#ok<NASGU>
      
      % in some future: check for warnings
      %gdat_out = verifyWarningFree(testCase,eval(gdat_call),...
      %  'Warning issued from gdat call:\n   %s\n',gdat_call);
      
      % (add optional sanity checks of gdat_out here)
    end
  end
end